{-# LANGUAGE PatternSynonyms, ScopedTypeVariables, ViewPatterns #-}


{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GstBase.Constants
    ( 
    pattern BASE_TRANSFORM_SRC_NAME         ,
    pattern BASE_TRANSFORM_SINK_NAME        ,
    pattern BASE_PARSE_FLAG_LOST_SYNC       ,
    pattern BASE_PARSE_FLAG_DRAINING        ,

    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


{- |
The name of the templates for the source pad.
-}
pattern BASE_TRANSFORM_SRC_NAME = "src" :: T.Text

{- |
The name of the templates for the sink pad.
-}
pattern BASE_TRANSFORM_SINK_NAME = "sink" :: T.Text

{- |
/No description available in the introspection data./
-}
pattern BASE_PARSE_FLAG_LOST_SYNC = 1 :: Int32

{- |
/No description available in the introspection data./
-}
pattern BASE_PARSE_FLAG_DRAINING = 2 :: Int32


